/*********************************************************************************
*
*               SHARP MZ-80B/80B2/2000/2200 Emulator for Win32
*
*                        EmuZ-2000  Extend Board DLL
*
*                               << EmuZ-1M10 >>
*
*                          Main Module [emuz_1m10.c]
*
*               Programmed by 2016-7 Takky
*
*********************************************************************************/
//
//
// Visual Studiǒx
#define _CRT_SECURE_NO_WARNINGS 1

#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <string.h>
//#include <alloc.h>
#include <errno.h>
#include <ctype.h>
//#include <dir.h>

#include "resource.h"
#include "..\interface\emuz2000ioBoard.h"
//Support Debugger
//#include "..\interface\emuz2000debug.h"
#include "..\interface\plugin_ex.h"
#include "emuz_1m10.h"

////////////////////////////////////
// Prototype 
////////////////////////////////////
UCHAR InportFunction(USHORT);
int OutportFunction(USHORT, UCHAR);
static int isHex(char *);
static int isAddr(char *);
static void upper(char *, char *);
static void BinaryProc(const char *, const char *, int);
//2022-01-05 del static void TextProc(const char *, int , int, int, int, int);
static void TextProc(HWND, const char *, int , int, int, int, int); // 2022-01-05 add
BOOL WINAPI About(HWND, UINT, WPARAM, LPARAM);
BOOL WINAPI MessageProc(HWND, unsigned, WORD, LONG); // 2022-01-05 add

////////////////////////////////////
// Global Variable 
////////////////////////////////////
#define	TITLE_LINE	"EmuZ-2000c["
HINSTANCE		h_instdll = NULL ;
static char *cpStateBuffer = NULL;
static char mbuf[512];	// 2022-01-05 add

EMUZ2000EBIH	emuz_1m10EBIH = {
	"1AE6C82F-E163-46EF-8816-9E9EBA815125",
	"EmuZ-1M10 MemoryChanger",
	"EmuZ-1M10 Version " EmuZ1M10_VERSION,
	"Copyright 2016-22 by Takky",
	"http://mio.servequake.com/~takky/emuz2000/",
	"takky386@gmail.com",
	0x00000000,	//Reserved
	InportFunction,
	OutportFunction,
	0x80,
	0x00,
	USE_INFODIALOG | USE_MAINMEMORY
} ;

DWORD	gId = 0 ;
DWORD	dwBase = 0x80 ;

//////////////////////////////////////////////////////////////////////////////////////
// Logic Start

static int isHex(char *buf)
{
	if ((((*buf >='0') && (*buf <='9')) || ((*buf >='A') && (*buf <='F'))) &&
		(((*(buf+1) >='0') && (*(buf+1) <='9')) || ((*(buf+1) >='A') && (*(buf+1) <='F'))))
		return 1;
	else
		return 0;
}

static int isAddr(char *buf)
{
	if ((((*buf >='0') && (*buf <='9')) || ((*buf >='A') && (*buf <='F'))) &&
		(((*(buf+1) >='0') && (*(buf+1) <='9')) || ((*(buf+1) >='A') && (*(buf+1) <='F'))) &&
		(((*(buf+2) >='0') && (*(buf+2) <='9')) || ((*(buf+2) >='A') && (*(buf+2) <='F'))) &&
		(((*(buf+3) >='0') && (*(buf+3) <='9')) || ((*(buf+3) >='A') && (*(buf+3) <='F'))))
		return 1;
	else
		return 0;
}

static void upper(char *dst, char *src)
{
	while (*src) {
		*dst = toupper(*src);
		dst++;
		src++;
	}
}

//
///////////////////////////////////////////////////////
// System interface
///////////////////////////////////////////////////////
BOOL WINAPI
DllMain(
	HINSTANCE	inst,
	DWORD		q_mode,
	LPVOID		vp_res_c )
{
	switch (q_mode) {
	case DLL_PROCESS_ATTACH :
		h_instdll = inst;
		break;
	case DLL_THREAD_ATTACH :
		break;
	case DLL_THREAD_DETACH :
		break;
	case DLL_PROCESS_DETACH :
		h_instdll = NULL;
		break;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////
// EmuZ-2000 Interface
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Dialog Callback
/////////////////////////////////////////////////////////////////////
BOOL WINAPI
InfomationDlgProc(
	HWND hWnd,
	UINT message,
	WPARAM wParam,
	LPARAM lParam)
{
static char szDumpFileName[MAX_PATH];
static char szDropFileName[MAX_PATH];
static int	bType = 0;
static int	bSum = 1;
static int	bAddSum = 0;
static int	bLowOnly = 0;
static int	bOhMZsum = 0;
static int	bUnixText = 0;
static char szStartAddr[5];
static int	bCRC = 0;
OPENFILENAME	OFN;
char	Filter[256], szCurDir[MAX_PATH];
int	sPos;
POINT ptDrop;

	switch (message) {
/** _CAȌ **/
		case WM_INITDIALOG:
			DragAcceptFiles(hWnd, TRUE);
			memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
			if (bType == 0)
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON1);
			else
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON2);
			if (bSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX1, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX1, TRUE);
			if (bAddSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX2, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX2, TRUE);
			if (bLowOnly == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX3, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX3, TRUE);
			if (bOhMZsum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX5, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX5, TRUE);
			if (bCRC == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX7, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX7, TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), TRUE);
			if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
				EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
			else
				EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), FALSE);
			break;

/** t@C̃hbv **/
		case WM_DROPFILES:
			/* hbvꂽt@C1ڂ̗pă_CAO֏o */
			DragQueryPoint((HDROP)wParam, &ptDrop);
			DragQueryFile((HDROP)wParam, 0, szDropFileName, MAX_PATH);
			DragFinish((HDROP)wParam);
			SetDlgItemText(hWnd, IDC_EDIT2, szDropFileName);
			strcpy(szDumpFileName, szDropFileName);
			InvalidateRect(hWnd, NULL, TRUE);
			break;

		// {^ñR}h
		case WM_COMMAND:
			switch(wParam) {
				case IDC_RADIOBUTTON1:
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), TRUE);
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
					else
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), FALSE);
					break;

				case IDC_RADIOBUTTON2:
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), TRUE);
					break;

				case IDC_CHECKBOX2:
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
					else
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					break;

				case IDC_BUTTON2:	// _vt@CQ
					/* J_CAOoăt@CIĂ炤 */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "_vt@C (*.*)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.*");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = h_instdll;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.lpstrInitialDir = NULL;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "_vt@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = 0;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT2, OFN.lpstrFile);
						strcpy(szDumpFileName, OFN.lpstrFile);
						InvalidateRect(hWnd, NULL, TRUE);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON3:	// _vf
					if (strlen(szDumpFileName) == 0) {
						MessageBox(NULL, "_vt@Cw肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					if (IsDlgButtonChecked(hWnd, IDC_RADIOBUTTON1))
						bType = 0;
					else
						bType = 1;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX1))
						bSum = 1;
					else
						bSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX6))
						bUnixText = 1;
					else
						bUnixText = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						bAddSum = 1;
					else
						bAddSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX5))
						bOhMZsum = 1;
					else
						bOhMZsum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX3))
						bLowOnly = 1;
					else
						bLowOnly = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX7))
						bCRC = 1;
					else
						bCRC = 0;
					memset(szStartAddr, 0x00, sizeof(szStartAddr));
					GetDlgItemText(hWnd, IDC_EDIT3, szStartAddr, 5);
					if (bType == 1) {
						BinaryProc(szDumpFileName, szStartAddr, bUnixText);
					} else {
//2022-01-05 del						TextProc(szDumpFileName, bSum, bAddSum, bLowOnly, bOhMZsum, bCRC);
						TextProc(hWnd, szDumpFileName, bSum, bAddSum, bLowOnly, bOhMZsum, bCRC);
					}
					break;

				case IDC_BUTTON5:		// About...{^
					/* About̃_CAOo */
					DialogBox(h_instdll, "AboutBox", hWnd, (DLGPROC)About);
					break;

				case IDCANCEL:	// I{^
					EndDialog(hWnd, FALSE );
					return	TRUE;

			}
			break;
	}
	return (FALSE);
}

/** AboutBox_CAO{ OK{^ꂽIBȊO͉Ȃ **/
BOOL WINAPI
About(
	HWND hDlg,
	UINT message,
	WPARAM wParam,
	LPARAM lParam)
{
	switch (message) {
		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}

// 2022-01-05 add start
/** MessageBox_CAO{ OK{^ꂽIBȊO͉Ȃ **/
BOOL WINAPI MessageProc(HWND hDlg, unsigned message, WORD wParam,
		LONG lParam)
{

	switch (message) {
		case WM_INITDIALOG:
			SetDlgItemText(hDlg, IDC_EDIT5, mbuf);
			break;

		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}
// 2022-01-05 add end
/////////////////////////////////////////////////////////////////////
// Board Information Service
/////////////////////////////////////////////////////////////////////
BOOL WINAPI
BoardInfomationService( 
	PEMUZ2000EBIH *info,
	DWORD id)
{

	*info = &emuz_1m10EBIH ;
	gId = id ;
	return	TRUE ;
}

/////////////////////////////////////////////////////////////////////
// Initialize Board
/////////////////////////////////////////////////////////////////////
BOOL WINAPI
IntializeBoard( 
	VOID)
{
	// |[gԍݒ
/*
	dwBase = emuz2000_readProfileDword( gId, "BaseAddress" ) ;
	switch( dwBase )
	{
	case	0x80:
		break ;
	default:
		dwBase = 0x80 ;
		break ;
	}
	// I/O |[gAhX擾
	emuz_1m10EBIH.ioMapper.ucStartPort = (UCHAR)dwBase ;
*/
	/* C̃AhX擾 */
	cpStateBuffer = emuz2000_getMainMemoryPointer( gId );
	return	TRUE ;
}

/////////////////////////////////////////////////////////////////////
// ReInitialize Board
/////////////////////////////////////////////////////////////////////
BOOL WINAPI
ReIntializeBoard( 
	VOID)
{
	return	TRUE ;
}

/////////////////////////////////////////////////////////////////////
// Finalize Board
/////////////////////////////////////////////////////////////////////
VOID WINAPI
FinalizeBoard( 
	VOID)
{
/*
	emuz2000_writeProfileDword( gId, "BaseAddress", dwBase ) ;
*/
	return ;
}

/////////////////////////////////////////////////////////////////////
// Report CPU Clock
/////////////////////////////////////////////////////////////////////
VOID WINAPI
ReportCpuClock( 
	int clk)
{
	return ;
}

/////////////////////////////////////////////////////////////////////
// Information Dialog
/////////////////////////////////////////////////////////////////////
VOID WINAPI
InfomationDialog( 
	HWND	hWnd)
{
	DialogBox( h_instdll, "MainDialog", hWnd, InfomationDlgProc);
	return ;
}

/////////////////////////////////////////////////////////////////////
// State Save Output
/////////////////////////////////////////////////////////////////////
#ifdef EMUZ2000EX
BOOL WINAPI
StateSaveOutputDataEx(
	int *ver,
	DWORD *size,
	PUCHAR *buf)
{
	*size = 0;
	*buf = NULL;
	*ver = 1;				/* Data Format Ver.1 */
	return TRUE;
}
#else
BOOL WINAPI
StateSaveOutputData( 
	DWORD *size,
	PUCHAR buf)
{
	*size = 0 ;
	buf = NULL ;
	return	TRUE ;
}
#endif

/////////////////////////////////////////////////////////////////////
// State Save Input
/////////////////////////////////////////////////////////////////////
#ifdef EMUZ2000EX
BOOL WINAPI
StateSaveInputDataEx(
	int ver,
	DWORD size,
	PUCHAR buf)
{
	return TRUE;
}
#else
BOOL WINAPI
StateSaveInputData( 
	DWORD size,
	PUCHAR buf)
{
	return	TRUE ;
}
#endif

/////////////////////////////////////////////////////////////////////
// Input Function Interface
/////////////////////////////////////////////////////////////////////
UCHAR
InportFunction(
	USHORT	port)
{
	UCHAR	data = 0 ;

	switch( port )
	{
	case	0x80:
		break ;
	}
	return	data ;
}

/////////////////////////////////////////////////////////////////////
// Output Function Interface
/////////////////////////////////////////////////////////////////////
int
OutportFunction(
	USHORT	port,
	UCHAR	data)
{
	switch( port )
	{
	case	0x80:
		break ;
	}

	return	0 ;
}

/////////////////////////////////////////////////////////////////////
// Binary dump
/////////////////////////////////////////////////////////////////////
static void
BinaryProc(
	const char *szFileName,
	const char *saddr,
	int bUnixText)
{
long lStartAddr;
long lsAdr, leAdr;
HANDLE hFile;
HGLOBAL hMem2;
DWORD dwSize, dwErr, dwReadSize;
char buf[256], *cpDumpBuffer;
char *dst, *src;

	lStartAddr = strtol(saddr, NULL, 16);
	if ((hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, "_vt@CI[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((dwSize = GetFileSize(hFile, NULL)) == 0xffffffff) {
		dwErr = GetLastError();
		if (dwErr != NO_ERROR) {
			memset(buf, 0x00, sizeof(buf));
			snprintf(buf, sizeof(buf), "_vt@C̃TCY擾ŃG[܂(%d)", dwErr);
			MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return;
		}
	}
	if ((lStartAddr + dwSize) >= 65536) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@C傫邩JnAhX傫܂B\n_vt@CTCY:%d",
			dwSize);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((hMem2 = GlobalAlloc(GMEM_FIXED, dwSize)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((cpDumpBuffer = (char *)GlobalLock(hMem2)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, cpDumpBuffer, dwSize, &dwReadSize, NULL);
	if (dwSize != dwReadSize) {
		MessageBox(NULL, "_vt@Cǂݍ߂܂ł", TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalUnlock(hMem2);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);

	lsAdr = lStartAddr;
	leAdr = lStartAddr + dwSize - 1;
	/* Xe[gZ[uł͂Ȃ̃C[WAhX܂ŃXLbv͕sv */
	if (bUnixText == 0)
		memcpy((cpStateBuffer+lStartAddr), cpDumpBuffer, dwSize);
	else {
		dst = (cpStateBuffer+lStartAddr);
		src = cpDumpBuffer+18; /* UNIXpwb_̍폜 */
		leAdr -= 18;
		while (dwSize > 0) {
			if (*src == 0x0a)
				*dst = 0x0d;   /* LF->CR */
			else
				*dst = *src;
			dst++;
			src++;
			dwSize--;
		}
		*dst = 0x00; /* NULL } */
	}
	GlobalUnlock(hMem2);
	GlobalFree(hMem2);
	memset(buf, 0x00, sizeof(buf));
	snprintf(buf, sizeof(buf), "܂\nAhX:$%04X - $%04X", lsAdr, leAdr);
	MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}

/////////////////////////////////////////////////////////////////////
// Text dump
/////////////////////////////////////////////////////////////////////
static void
TextProc(
	HWND hWnd,	//2022-01-05 add
	const char *szFileName,
	int bSum,
	int bAddSum,
	int bLowOnly,
	int bOhMZsum,
	int bCRC)
{
FILE *fp;
char rbuf[1024], cbuf[1024], buf[512], *cp, tmp[16];
long iSum, iVSum[16], iASum;
char adr[5], data[17][4];
unsigned char wbuf[16];
int iNum, i, j, isErr, iNum2, iNum3;
long lStartAddr, cdata, lsAdr, leAdr;
int clen;
char mzsum[4], mzvsum[5];
unsigned short crcSum;
unsigned char crcData;

	if ((fp = fopen(szFileName, "r")) == NULL) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@CI[vł܂(%d)", errno);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		return;
	}
	lsAdr = 65536;
	leAdr = 0;
	iSum = 0;
	iASum = 0;
	isErr = 0;
	crcSum = 0;
	memset((void *)iVSum, 0x00, sizeof(iVSum));
	memset(rbuf, 0x00, sizeof(rbuf));
	memset(cbuf, 0x00, sizeof(cbuf));
	while (fgets(rbuf, sizeof(rbuf), fp) != NULL) {
		if (strlen(rbuf) <=3) continue;
		upper(cbuf, rbuf);
		if (isAddr(cbuf)) {
			cp = strtok(cbuf, " \n");
			strncpy(adr, cp, 5);
			iNum = 0;
			while ((cp = strtok(NULL, " \n")) != NULL) {
				if ((clen = strlen(cp)) <= 2)
					strncpy(data[iNum], cp , 3);
				else {
					if (bOhMZsum == 1) {
						memset(mzsum, 0x00, sizeof(mzsum));
						data[iNum][0] = *(cp+1);
						strncpy(&data[iNum][1], (cp+3) , 2);
					} else {
						strncpy(data[iNum], (cp+clen-2) , 3);
					}
				}
				if (bCRC == 1) {
					/* Oh!XCRC^Cv̏ꍇA:̎ɃXy[X̂Ŗ */
					if (data[iNum][0] == ':')
						;
					else
						iNum++;
				} else
					iNum++;
				if (iNum > 16) break;
			}
			lStartAddr = strtol(adr, NULL, 16);
			if (lStartAddr >= 0 || lStartAddr <= 65535) {
				for (i=0; i<(bSum == 1 ? iNum-1 : iNum); i++) {
					if (!isHex(data[i])) {
						fclose(fp);
//2022-01-05 del						memset(buf, 0x00, sizeof(buf));
//2022-01-05 del						snprintf(buf, sizeof(buf), "f[^G[\n@OAhX:%s\n@ItZbg:%02X\n@f[^:%s", adr, i, data[i]);
//2022-01-05 del						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						// 2022-01-05 add start
						memset(mbuf, 0x00, sizeof(mbuf));
						snprintf(mbuf, sizeof(mbuf), "f[^G[\r\n@OAhX:%s\r\n@ItZbg:%02X\r\n@f[^:%s\r\n(E00)", adr, i, data[i]);
						DialogBox(h_instdll, "ResultBox", hWnd, (DLGPROC)MessageProc);
						// 2022-01-05 add end
						return;
					}
					cdata = strtol(data[i], NULL, 16);
					iSum += cdata;
					wbuf[i] = (unsigned char)cdata;
					iVSum[i] += cdata;
					iASum += cdata;
					if (bCRC == 1) {
						crcData = (unsigned char)cdata;
						for (j=0; j<8; j++) {
							if ((crcSum & 0x8000) != 0) {
								crcSum = crcSum << 1;
								crcSum = crcSum ^ 0x1021;
							} else {
								crcSum = crcSum << 1;
							}
							if ((crcData & 0x80) != 0) {
								crcData = crcData << 1;
								crcSum = crcSum ^ 0x0001;
							} else {
								crcData = crcData << 1;
							}
						}
					}
				}
				if (bSum == 1) {
					if (bAddSum == 1) {
						if (bLowOnly == 1)
							iSum += (lStartAddr & 0x000000ff);
						else
							iSum += ((lStartAddr & 0x000000ff) + ((lStartAddr >> 8) & 0x000000ff));
					}
					if (bOhMZsum == 1) {
						iSum = iSum & 0x00000fff;
					} else {
						iSum = iSum & 0x000000ff;
					}
					if (iSum != strtol(data[iNum-1], NULL, 16)) {
						fclose(fp);
//2022-01-05 del						memset(buf, 0x00, sizeof(buf));
						memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
						if (bOhMZsum == 1) {
//2022-01-05 del							snprintf(buf, sizeof(buf), "`FbNTG[\n@AhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%03X", adr, data[iNum-1], iSum);
							snprintf(mbuf, sizeof(mbuf), "`FbNTG[\r\n@AhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%03X\r\n(E02)", adr, data[iNum-1], iSum); // 2022-01-05 add
						} else {
//2022-01-05 del							snprintf(buf, sizeof(buf), "`FbNTG[\n@AhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%02X", adr, data[iNum-1], iSum);
							snprintf(mbuf, sizeof(mbuf), "`FbNTG[\r\n@AhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%02X\r\n(E03)", adr, data[iNum-1], iSum); // 2022-01-05 add
						}
//2022-01-05 del						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						DialogBox(h_instdll, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
						return;
					}
				}
				if (lsAdr > lStartAddr) lsAdr = lStartAddr;
				if (leAdr < (lStartAddr+(bSum == 1 ? iNum-2 : iNum-1)))
					leAdr = (lStartAddr+(bSum == 1 ? iNum-2 : iNum-1));
				/* Xe[gZ[uł͂Ȃ̃C[WAhX܂ŃXLbv͕sv */
				memcpy((cpStateBuffer+lStartAddr), wbuf, (bSum == 1 ? iNum-1 : iNum));
			}
		} else if (bSum == 1 && memcmp(cbuf, "SUM", 3) == 0) {
			cp = strtok(cbuf, " \n");
//2022-01-05 del			memset(buf, 0x00, sizeof(buf));
//2022-01-05 del			snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n", adr);
			memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
			snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n", adr); // 2022-01-05 add
			iNum3 = 0;
			while (cp != NULL) {
				cp = strtok(NULL, " \n");
				if (cp != NULL && strlen(cp) == 2)
					iNum3++;
			}
			upper(cbuf, rbuf);
			cp = strtok(cbuf, " \n");
			for (iNum2 = 0; iNum2 < iNum3; iNum2++) {
				cp = strtok(NULL, " \n");
				if (!isHex(cp)) {
					fclose(fp);
//2022-01-05 del					memset(buf, 0x00, sizeof(buf));
//2022-01-05 del					snprintf(buf, sizeof(buf), "`FbNTf[^G[\n@OAhX:%s\n@ItZbg:+%02X\n@f[^:%s", adr, iNum2, cp);
//2022-01-05 del					MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
					memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
					snprintf(mbuf, sizeof(mbuf), "`FbNTf[^G[\r\n@OAhX:%s\r\n@ItZbg:+%02X\r\n@f[^:%s\r\n(E04)", adr, iNum2, cp); // 2022-01-05 add
					DialogBox(h_instdll, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
					return;
				}
				if ((iVSum[iNum2] & 0x00ff) != strtol(cp, NULL, 16)) {
//2022-01-05 del					strcat(buf, "@@+");
					strcat(mbuf, "@@+"); // 2022-01-05 add
					memset(tmp, 0x00, sizeof(tmp));
					tmp[0] = (char)(((iNum2 < 10) ? iNum2+0x30 : iNum2+0x37) & 0x00ff);
//2022-01-05 del					strcat(buf, tmp);
//2022-01-05 del					strcat(buf, "@");
//2022-01-05 del					strcat(buf, cp);
					strcat(mbuf, tmp); // 2022-01-05 add
					strcat(mbuf, "@"); // 2022-01-05 add
					strcat(mbuf, cp); // 2022-01-05 add
					memset(tmp, 0x00, sizeof(tmp));
					snprintf(tmp, sizeof(tmp), "/%02X\n", (iVSum[iNum2] & 0x00ff));
//2022-01-05 del					strcat(buf, tmp);
					strcat(mbuf, tmp); // 2022-01-05 add
					isErr = 1;
				}
			}
			if (isErr) {
				fclose(fp);
//2022-01-05 del				MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
				strcat(mbuf, "\r\n(E05)"); // 2022-01-05 add
				DialogBox(h_instdll, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
				return;
			} else {
				cp = strtok(NULL, " \n");
				memset(tmp, 0x00, sizeof(tmp));
				if (bCRC == 0) {
					if ((clen = strlen(cp)) <= 2)
						strncpy(tmp, cp , 3);
					else
						strncpy(tmp, (cp+clen-2) , 3);
					if ((iASum & 0x00ff) != strtol(tmp, NULL, 16)) {
						fclose(fp);
//2022-01-05 del						memset(buf, 0x00, sizeof(buf));
//2022-01-05 del						snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%02X", adr, tmp, (iASum & 0x00ff));
//2022-01-05 del						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
						snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%02X\r\n(E06)", adr, tmp, (iASum & 0x00ff)); // 2022-01-05 add
						DialogBox(h_instdll, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
						return;
					}
				} else {
					strncpy(tmp, cp , 4);
					if (crcSum != strtol(tmp, NULL, 16)) {
						fclose(fp);
//2022-01-05 del						memset(buf, 0x00, sizeof(buf));
//2022-01-05 del						snprintf(buf, sizeof(buf), "bqbG[\n@OAhX:%s\n@wbqb:%s\n@Zobqb:%04X", adr, tmp, crcSum);
//2022-01-05 del						MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
						snprintf(mbuf, sizeof(mbuf), "bqbG[\r\n@OAhX:%s\r\n@wbqb:%s\r\n@Zobqb:%04X\r\n(E07)", adr, tmp, crcSum); // 2022-01-05 add
						DialogBox(h_instdll, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
						return;
					}
				}
			}
			isErr = 0;
			iASum = 0;
			crcSum = 0;
			memset((void *)iVSum, 0x00, sizeof(iVSum));
		} else if (bOhMZsum == 1 && memcmp(cbuf, "------------------------------", 30) == 0) {
			memset(mzvsum, 0x00, sizeof(mzvsum));
			memcpy(mzvsum, &cbuf[strlen(cbuf)-5], 4);
			if ((iASum & 0xffff) != strtol(mzvsum, NULL, 16)) {
				fclose(fp);
//2022-01-05 del				memset(buf, 0x00, sizeof(buf));
//2022-01-05 del				snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%04X", adr, mzvsum, (iASum & 0xffff));
//2022-01-05 del				MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
				memset(mbuf, 0x00, sizeof(mbuf)); // 2022-01-05 add
				snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%04X\r\n(E08)", adr, mzvsum, (iASum & 0xffff)); // 2022-01-05 add
				DialogBox(h_instdll, "ResultBox", hWnd, (DLGPROC)MessageProc); // 2022-01-05 add
				return;
			}
			isErr = 0;
			iASum = 0;
			memset((void *)iVSum, 0x00, sizeof(iVSum));
		}
		iSum = 0;
		memset(rbuf, 0x00, sizeof(rbuf));
		memset(cbuf, 0x00, sizeof(cbuf));
	}
	fclose(fp);
	memset(buf, 0x00, sizeof(buf));
	snprintf(buf, sizeof(buf), "܂\nAhX:$%04X - $%04X", lsAdr, leAdr);
	MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}
